码迷,mamicode.com
首页 > 编程语言 > 详细

leetcode——169 Majority Element(数组中出现次数过半的元素)

时间:2015-06-23 10:13:52      阅读:167      评论:0      收藏:0      [点我收藏+]

标签:leetcode   hashmap   数组   算法   java   

Given an array of size n, find the majority element. The majority element is the element that appears more than  n/2  times.
You may assume that the array is non-empty and the majority element always exist in the array.

Hide Tags: Divide and Conquer Array Bit Manipulation

解题思路:
(1)使用HashMap,Map的特点:不允许重复元素,因此在存储前需要判断是否存在
(2)判断HashMap中存在nums[i],如果存在,使用hm.get(nums[i])获取value,即通过key来获得value值,即count(出现的次数)
(3)如果count大于数组长度的一般,即返回该元素
(4)如果count不满足条件,向HashMap存储元素以及出现的次数。


代码如下:

	public static int majorityElement(int[] nums)
	{
		/*
		 * Map的特点:不允许重复元素,因此在存储前需要判断是否存在
		 */
		Map<Integer, Integer> hm=new HashMap<Integer, Integer>();
		for (int i = 0; i < nums.length; i++)
		{
			int count=0;
			//判断HashMap中存在nums[i],如果存在,使用hm.get(nums[i])获取value
			//即通过key来获得value值,即count(出现的次数)
			if (hm.containsKey(nums[i]))
			{
				count=hm.get(nums[i])+1;
			}
			else
			{
				count=1;
			}
			//如果count大于数组长度的一般,即返回该元素
			if (count>nums.length/2)
			{
				return nums[i];
			}
			//向HashMap存储元素以及出现的次数
			hm.put(nums[i], count);
		}
		return 0;
		
	}

leetcode——169 Majority Element(数组中出现次数过半的元素)

标签:leetcode   hashmap   数组   算法   java   

原文地址:http://blog.csdn.net/zzc8265020/article/details/46602295

(0)
(0)
   
举报
评论 一句话评论(0
登录后才能评论!
© 2014 mamicode.com 版权所有  联系我们:gaon5@hotmail.com
迷上了代码!